leetcode-question1

版权声明:本文为博主原创文章,未经博主允许不得转载。 https://blog.csdn.net/ceoicac/article/details/80281080

题目描述

给定一个整数数组和一个目标值,找出数组中和为目标值的两个数。你可以假设每个输入只对应一种答案,且同样的元素不能被重复利用。

示例:

给定 nums = [2, 7, 11, 15], target = 9 因为 nums[0] + nums[1] = 2 + 7 = 9 所以返回 [0, 1]

思路

运用HashMap来存储数组中元素的位置,用target减去元素中的某一个值,并记录这个元素在数组中的位置,如果得到的结果值是数组中的某一个元素,则通过map获取它在数组中的位置,然后返回。

代码

import java.util.HashMap;
class Solution {
    public int[] twoSum(int[] nums, int target) {
        int [] ret = new int[2];
        HashMap<Integer,Integer> map = new HashMap<Integer,Integer>();
        for(int i = 0;i < nums.length;++ i){
           map.put(nums[i],i);
        }
        for(int i = 0; i < nums.length;++ i){
            int tem = target - nums[i];
            if(map.get(tem) != null && map.get(tem) != i){
                ret[0] = i;
                ret[1] = map.get(tem);
                return ret;
            }
        }

        return ret;

    }
}

猜你喜欢

转载自blog.csdn.net/ceoicac/article/details/80281080